// EnterView.cpp : implementation file
//

#include "stdafx.h"
#include "Chess.h"
#include "EnterView.h"
#include "ChessDoc.h"
#include "ctype.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEnterView

IMPLEMENT_DYNCREATE(CEnterView, CFormView)

CEnterView::CEnterView()
	: CFormView(CEnterView::IDD)
{
	//AfxMessageBox("CEnterView");
	//CChessDoc *pDoc=(CChessDoc*)GetDocument();
	//if(pDoc->m_bFileOpen)
	//	return;
	m_N=3;
	m_NUM=9;
	
	//UpdateData(FALSE);
	//{{AFX_DATA_INIT(CEnterView)
	m_strEnd44_0 = _T("F");
	m_strEnd44_1 = _T("E");
	m_strEnd44_2 = _T("D");
	m_strEnd44_3 = _T("C");
	m_strEnd44_4 = _T("B");
	m_strEnd44_5 = _T("A");
	m_strEnd44_6 = _T("9");
	m_strEnd44_7 = _T("8");
	m_strEnd44_8 = _T("7");
	m_strEnd44_9 = _T("6");
	m_strEnd44_A = _T("5");
	m_strEnd44_B = _T("0");
	m_strEnd44_C = _T("3");
	m_strEnd44_D = _T("2");
	m_strEnd44_E = _T("1");
	m_strEnd44_F = _T("4");
	m_strStart44_0 = _T("F");
	m_strStart44_2 = _T("D");
	m_strStart44_3 = _T("C");
	m_strStart44_4 = _T("B");
	m_strStart44_5 = _T("A");
	m_strStart44_6 = _T("9");
	m_strStart44_7 = _T("8");
	m_strStart44_8 = _T("7");
	m_strStart44_9 = _T("6");
	m_strStart44_B = _T("4");
	m_strStart44_C = _T("3");
	m_strStart44_A = _T("5");
	m_strStart44_D = _T("2");
	m_strStart44_E = _T("1");
	m_strStart44_F = _T("0");
	m_strStart44_1 = _T("E");
	m_nType = 1;
	m_strEnd33_0 = _T("1");
	m_strEnd33_1 = _T("2");
	m_strEnd33_2 = _T("3");
	m_strEnd33_3 = _T("8");
	m_strEnd33_4 = _T("0");
	m_strEnd33_5 = _T("4");
	m_strEnd33_6 = _T("7");
	m_strEnd33_7 = _T("6");
	m_strEnd33_8 = _T("5");
	m_strStart33_0 = _T("2");
	m_strStart33_1 = _T("8");
	m_strStart33_2 = _T("3");
	m_strStart33_3 = _T("1");
	m_strStart33_4 = _T("6");
	m_strStart33_5 = _T("4");
	m_strStart33_6 = _T("7");
	m_strStart33_7 = _T("0");
	m_strStart33_8 = _T("5");	
	m_nScale = 0;
	m_nDepth = 1000;
	//}}AFX_DATA_INIT
	
}

CEnterView::~CEnterView()
{
}

void CEnterView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEnterView)
	DDX_Control(pDX, IDC_EDIT_END_33_1, m_gridEnd33_1);
	DDX_Control(pDX, IDC_EDIT_END_33_0, m_gridEnd33_0);
	DDX_Control(pDX, IDC_EDIT_END_33_2, m_gridEnd33_2);
	DDX_Control(pDX, IDC_EDIT_END_33_3, m_gridEnd33_3);
	DDX_Control(pDX, IDC_EDIT_END_33_4, m_gridEnd33_4);
	DDX_Control(pDX, IDC_EDIT_END_33_5, m_gridEnd33_5);
	DDX_Control(pDX, IDC_EDIT_END_33_6, m_gridEnd33_6);
	DDX_Control(pDX, IDC_EDIT_END_33_7, m_gridEnd33_7);
	DDX_Control(pDX, IDC_EDIT_END_33_8, m_gridEnd33_8);
	DDX_Control(pDX, IDC_EDIT_START_33_0, m_gridStart33_0);
	DDX_Control(pDX, IDC_EDIT_START_33_1, m_gridStart33_1);
	DDX_Control(pDX, IDC_EDIT_START_33_2, m_gridStart33_2);
	DDX_Control(pDX, IDC_EDIT_START_33_3, m_gridStart33_3);
	DDX_Control(pDX, IDC_EDIT_START_33_4, m_gridStart33_4);
	DDX_Control(pDX, IDC_EDIT_START_33_5, m_gridStart33_5);
	DDX_Control(pDX, IDC_EDIT_START_33_6, m_gridStart33_6);
	DDX_Control(pDX, IDC_EDIT_START_33_7, m_gridStart33_7);
	DDX_Control(pDX, IDC_EDIT_START_33_8, m_gridStart33_8);
	DDX_Control(pDX, IDC_COMBO_TYPE, m_cboType);
	DDX_Control(pDX, IDC_EDIT_STARTF, m_gridStart44_F);
	DDX_Control(pDX, IDC_EDIT_STARTE, m_gridStart44_E);
	DDX_Control(pDX, IDC_EDIT_STARTD, m_gridStart44_D);
	DDX_Control(pDX, IDC_EDIT_STARTC, m_gridStart44_C);
	DDX_Control(pDX, IDC_EDIT_STARTB, m_gridStart44_B);
	DDX_Control(pDX, IDC_EDIT_STARTA, m_gridStart44_A);
	DDX_Control(pDX, IDC_EDIT_START9, m_gridStart44_9);
	DDX_Control(pDX, IDC_EDIT_START8, m_gridStart44_8);
	DDX_Control(pDX, IDC_EDIT_START7, m_gridStart44_7);
	DDX_Control(pDX, IDC_EDIT_START6, m_gridStart44_6);
	DDX_Control(pDX, IDC_EDIT_START5, m_gridStart44_5);
	DDX_Control(pDX, IDC_EDIT_START4, m_gridStart44_4);
	DDX_Control(pDX, IDC_EDIT_START3, m_gridStart44_3);
	DDX_Control(pDX, IDC_EDIT_START2, m_gridStart44_2);
	DDX_Control(pDX, IDC_EDIT_START1, m_gridStart44_1);
	DDX_Control(pDX, IDC_EDIT_START0, m_gridStart44_0);
	DDX_Control(pDX, IDC_EDIT_ENDF, m_gridEnd44_F);
	DDX_Control(pDX, IDC_EDIT_ENDE, m_gridEnd44_E);
	DDX_Control(pDX, IDC_EDIT_ENDD, m_gridEnd44_D);
	DDX_Control(pDX, IDC_EDIT_ENDC, m_gridEnd44_C);
	DDX_Control(pDX, IDC_EDIT_ENDB, m_gridEnd44_B);
	DDX_Control(pDX, IDC_EDIT_ENDA, m_gridEnd44_A);
	DDX_Control(pDX, IDC_EDIT_END9, m_gridEnd44_9);
	DDX_Control(pDX, IDC_EDIT_END7, m_gridEnd44_7);
	DDX_Control(pDX, IDC_EDIT_END8, m_gridEnd44_8);
	DDX_Control(pDX, IDC_EDIT_END6, m_gridEnd44_6);
	DDX_Control(pDX, IDC_EDIT_END5, m_gridEnd44_5);
	DDX_Control(pDX, IDC_EDIT_END4, m_gridEnd44_4);
	DDX_Control(pDX, IDC_EDIT_END3, m_gridEnd44_3);
	DDX_Control(pDX, IDC_EDIT_END2, m_gridEnd44_2);
	DDX_Control(pDX, IDC_EDIT_END1, m_gridEnd44_1);
	DDX_Control(pDX, IDC_EDIT_END0, m_gridEnd44_0);
	DDX_Text(pDX, IDC_EDIT_END0, m_strEnd44_0);
	DDV_MaxChars(pDX, m_strEnd44_0, 1);
	DDX_Text(pDX, IDC_EDIT_END1, m_strEnd44_1);
	DDV_MaxChars(pDX, m_strEnd44_1, 1);
	DDX_Text(pDX, IDC_EDIT_END2, m_strEnd44_2);
	DDV_MaxChars(pDX, m_strEnd44_2, 1);
	DDX_Text(pDX, IDC_EDIT_END3, m_strEnd44_3);
	DDV_MaxChars(pDX, m_strEnd44_3, 1);
	DDX_Text(pDX, IDC_EDIT_END4, m_strEnd44_4);
	DDV_MaxChars(pDX, m_strEnd44_4, 1);
	DDX_Text(pDX, IDC_EDIT_END5, m_strEnd44_5);
	DDV_MaxChars(pDX, m_strEnd44_5, 1);
	DDX_Text(pDX, IDC_EDIT_END6, m_strEnd44_6);
	DDV_MaxChars(pDX, m_strEnd44_6, 1);
	DDX_Text(pDX, IDC_EDIT_END7, m_strEnd44_7);
	DDV_MaxChars(pDX, m_strEnd44_7, 1);
	DDX_Text(pDX, IDC_EDIT_END8, m_strEnd44_8);
	DDV_MaxChars(pDX, m_strEnd44_8, 1);
	DDX_Text(pDX, IDC_EDIT_END9, m_strEnd44_9);
	DDV_MaxChars(pDX, m_strEnd44_9, 1);
	DDX_Text(pDX, IDC_EDIT_ENDA, m_strEnd44_A);
	DDV_MaxChars(pDX, m_strEnd44_A, 1);
	DDX_Text(pDX, IDC_EDIT_ENDB, m_strEnd44_B);
	DDV_MaxChars(pDX, m_strEnd44_B, 1);
	DDX_Text(pDX, IDC_EDIT_ENDC, m_strEnd44_C);
	DDV_MaxChars(pDX, m_strEnd44_C, 1);
	DDX_Text(pDX, IDC_EDIT_ENDD, m_strEnd44_D);
	DDV_MaxChars(pDX, m_strEnd44_D, 1);
	DDX_Text(pDX, IDC_EDIT_ENDE, m_strEnd44_E);
	DDV_MaxChars(pDX, m_strEnd44_E, 1);
	DDX_Text(pDX, IDC_EDIT_ENDF, m_strEnd44_F);
	DDV_MaxChars(pDX, m_strEnd44_F, 1);
	DDX_Text(pDX, IDC_EDIT_START0, m_strStart44_0);
	DDV_MaxChars(pDX, m_strStart44_0, 1);
	DDX_Text(pDX, IDC_EDIT_START2, m_strStart44_2);
	DDV_MaxChars(pDX, m_strStart44_2, 1);
	DDX_Text(pDX, IDC_EDIT_START3, m_strStart44_3);
	DDV_MaxChars(pDX, m_strStart44_3, 1);
	DDX_Text(pDX, IDC_EDIT_START4, m_strStart44_4);
	DDV_MaxChars(pDX, m_strStart44_4, 1);
	DDX_Text(pDX, IDC_EDIT_START5, m_strStart44_5);
	DDV_MaxChars(pDX, m_strStart44_5, 1);
	DDX_Text(pDX, IDC_EDIT_START6, m_strStart44_6);
	DDV_MaxChars(pDX, m_strStart44_6, 1);
	DDX_Text(pDX, IDC_EDIT_START7, m_strStart44_7);
	DDV_MaxChars(pDX, m_strStart44_7, 1);
	DDX_Text(pDX, IDC_EDIT_START8, m_strStart44_8);
	DDV_MaxChars(pDX, m_strStart44_8, 1);
	DDX_Text(pDX, IDC_EDIT_START9, m_strStart44_9);
	DDV_MaxChars(pDX, m_strStart44_9, 1);
	DDX_Text(pDX, IDC_EDIT_STARTB, m_strStart44_B);
	DDV_MaxChars(pDX, m_strStart44_B, 1);
	DDX_Text(pDX, IDC_EDIT_STARTC, m_strStart44_C);
	DDV_MaxChars(pDX, m_strStart44_C, 1);
	DDX_Text(pDX, IDC_EDIT_STARTA, m_strStart44_A);
	DDV_MaxChars(pDX, m_strStart44_A, 1);
	DDX_Text(pDX, IDC_EDIT_STARTD, m_strStart44_D);
	DDV_MaxChars(pDX, m_strStart44_D, 1);
	DDX_Text(pDX, IDC_EDIT_STARTE, m_strStart44_E);
	DDV_MaxChars(pDX, m_strStart44_E, 1);
	DDX_Text(pDX, IDC_EDIT_STARTF, m_strStart44_F);
	DDV_MaxChars(pDX, m_strStart44_F, 1);
	DDX_Text(pDX, IDC_EDIT_START1, m_strStart44_1);
	DDV_MaxChars(pDX, m_strStart44_1, 1);
	DDX_CBIndex(pDX, IDC_COMBO_TYPE, m_nType);
	DDX_Text(pDX, IDC_EDIT_END_33_0, m_strEnd33_0);
	DDV_MaxChars(pDX, m_strEnd33_0, 1);
	DDX_Text(pDX, IDC_EDIT_END_33_1, m_strEnd33_1);
	DDV_MaxChars(pDX, m_strEnd33_1, 1);
	DDX_Text(pDX, IDC_EDIT_END_33_2, m_strEnd33_2);
	DDV_MaxChars(pDX, m_strEnd33_2, 1);
	DDX_Text(pDX, IDC_EDIT_END_33_3, m_strEnd33_3);
	DDV_MaxChars(pDX, m_strEnd33_3, 1);
	DDX_Text(pDX, IDC_EDIT_END_33_4, m_strEnd33_4);
	DDV_MaxChars(pDX, m_strEnd33_4, 1);
	DDX_Text(pDX, IDC_EDIT_END_33_5, m_strEnd33_5);
	DDV_MaxChars(pDX, m_strEnd33_5, 1);
	DDX_Text(pDX, IDC_EDIT_END_33_6, m_strEnd33_6);
	DDV_MaxChars(pDX, m_strEnd33_6, 1);
	DDX_Text(pDX, IDC_EDIT_END_33_7, m_strEnd33_7);
	DDV_MaxChars(pDX, m_strEnd33_7, 1);
	DDX_Text(pDX, IDC_EDIT_END_33_8, m_strEnd33_8);
	DDV_MaxChars(pDX, m_strEnd33_8, 1);
	DDX_Text(pDX, IDC_EDIT_START_33_0, m_strStart33_0);
	DDV_MaxChars(pDX, m_strStart33_0, 1);
	DDX_Text(pDX, IDC_EDIT_START_33_1, m_strStart33_1);
	DDV_MaxChars(pDX, m_strStart33_1, 1);
	DDX_Text(pDX, IDC_EDIT_START_33_2, m_strStart33_2);
	DDV_MaxChars(pDX, m_strStart33_2, 1);
	DDX_Text(pDX, IDC_EDIT_START_33_3, m_strStart33_3);
	DDV_MaxChars(pDX, m_strStart33_3, 1);
	DDX_Text(pDX, IDC_EDIT_START_33_4, m_strStart33_4);
	DDV_MaxChars(pDX, m_strStart33_4, 1);
	DDX_Text(pDX, IDC_EDIT_START_33_5, m_strStart33_5);
	DDV_MaxChars(pDX, m_strStart33_5, 1);
	DDX_Text(pDX, IDC_EDIT_START_33_6, m_strStart33_6);
	DDV_MaxChars(pDX, m_strStart33_6, 1);
	DDX_Text(pDX, IDC_EDIT_START_33_7, m_strStart33_7);
	DDV_MaxChars(pDX, m_strStart33_7, 1);
	DDX_Text(pDX, IDC_EDIT_START_33_8, m_strStart33_8);
	DDV_MaxChars(pDX, m_strStart33_8, 1);
	DDX_Radio(pDX, IDC_RADIO_TYPE33, m_nScale);
	DDX_Text(pDX, IDC_EDIT_DEPTH, m_nDepth);
	DDV_MinMaxUInt(pDX, m_nDepth, 0, 32767);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEnterView, CFormView)
	//{{AFX_MSG_MAP(CEnterView)
	ON_BN_CLICKED(IDC_BUTTON_BEGIN, OnButtonBegin)
	ON_CBN_SELCHANGE(IDC_COMBO_TYPE, OnSelchangeComboType)
	ON_BN_CLICKED(IDC_RADIO_TYPE33, OnRadioType33)
	ON_BN_CLICKED(IDC_RADIO_TYPE44, OnRadioType44)
	ON_EN_CHANGE(IDC_EDIT_DEPTH, OnChangeEditDepth)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEnterView diagnostics

#ifdef _DEBUG
void CEnterView::AssertValid() const
{
	CFormView::AssertValid();
}

void CEnterView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEnterView message handlers

//DEL void CEnterView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
//DEL {
//DEL 	// TODO: Add your message handler code here and/or call default
//DEL 	AfxMessageBox("aaa");
//DEL 	//CFormView::OnChar(nChar, nRepCnt, nFlags);
//DEL }

void CEnterView::OnButtonBegin() 
{
	int i;
	unsigned char buf[15];

	CString tempChar;
	CChessDoc* pDoc=(CChessDoc*)GetDocument();
	CEdit *pEdit;
	UpdateData();
	for(i=0;i<m_NUM;i++)
	{

		if(m_N==3)
			pEdit=(CEdit*)GetDlgItem(IDC_EDIT_START_33_0+i);
		else 
			pEdit=(CEdit*)GetDlgItem(IDC_EDIT_START0+i);
		
		pEdit->GetWindowText(tempChar);
		if(tempChar.IsEmpty()) buf[i]='0';
		else 
		{
			if (isdigit(tempChar[0]))
				buf[i]=tempChar[0];
			else
				buf[i]=tempChar[0];
		}
	}
	if(ValidateGrid(buf,m_NUM))
	{
		memcpy(pDoc->m_strStart ,buf,m_NUM);
		pDoc->m_N=m_N;
		pDoc->m_NUM=m_NUM;
	}
	else
	{
		AfxMessageBox("̳ʼֳ¼飡");
		return;
	}


	for(i=0;i<m_NUM;i++)
	{
		if (m_N==3)
			pEdit=(CEdit*)GetDlgItem(IDC_EDIT_END_33_0+i);
		else
			pEdit=(CEdit*)GetDlgItem(IDC_EDIT_END0+i);
		pEdit->GetWindowText(tempChar);
		if(tempChar.IsEmpty()) buf[i]='0';
		else 
		{
			if (isdigit(tempChar[0]))
				buf[i]=tempChar[0];
			else
				buf[i]=tempChar[0];
		}

	}
	if(ValidateGrid(buf,m_NUM))
		memcpy(pDoc->m_strEnd,buf,m_NUM);
	else
	{
		AfxMessageBox("Ŀ겼ֳ¼飡");
		return;
	}

	//char tempbuf[80];
	//sprintf(tempbuf,"%s\n%s",pDoc->m_strStart,pDoc->m_strEnd);
	//AfxMessageBox(tempbuf);
	if(memcmp(pDoc->m_strStart,pDoc->m_strEnd,m_NUM)==0 )
	{
		AfxMessageBox("̳ʼֺĿ겼ͬ");
		return;
	}
	else if(pDoc->Test(pDoc->m_strStart,pDoc->m_strEnd,m_N,m_NUM)!=0)
	{
		AfxMessageBox("̳ʼֵĿ겼֣");
		return;
	}
	pDoc->m_nResult=0;
	pDoc->m_nType=m_nType;
	pDoc->m_N=m_N;
	pDoc->m_NUM=m_NUM;
	pDoc->m_bBeginDraw=TRUE;
	pDoc->m_nDepth=m_nDepth;
	switch(m_nType)
	{
	case 0:
		pDoc->BFS(pDoc->m_strStart,pDoc->m_strEnd );
		if(pDoc->m_nResult<=0)
		{
			AfxMessageBox("û·");
		}
		break;
	case 1: 
		pDoc->SearchDFS();
		if(pDoc->m_nResult<=0)
		{
			AfxMessageBox("û·");
		}
		break;
	case 2:
		pDoc->BFSA1(pDoc->m_strStart,pDoc->m_strEnd );
		if(pDoc->m_nResult<=0)
		{
			AfxMessageBox("û·");
		}
		break;
	case 3:
		pDoc->BFSA2(pDoc->m_strStart,pDoc->m_strEnd );
		if(pDoc->m_nResult<=0)
		{
			AfxMessageBox("û·");
		}
		break;
	case 4:
		pDoc->BFSA3(pDoc->m_strStart,pDoc->m_strEnd );
		if(pDoc->m_nResult<=0)
		{
			AfxMessageBox("û·");
		}
		break;
	default: break;
	}
	
	pDoc->UpdateAllViews(this);
}

BOOL CEnterView::ValidateGrid( unsigned char* buf, UINT scale)
{
	UINT *num=new UINT[scale];
	UINT i;

	for(i=0;i<scale;i++) num[i]=0;
	
	for(i=0;i<scale;i++)
	{
		if (isdigit(buf[i]))
			num[buf[i]-'0']++;
		else
			num[buf[i]-'A'+10]++;
	}
	for(i=0;i<scale;i++)
	{
		if (num[i]!=1) 
		{
			delete[] num;
			return FALSE;
		}
	}
	delete[] num;
	return TRUE;
		
}

void CEnterView::OnSelchangeComboType() 
{
	// TODO: Add your control notification handler code here
	m_nType=m_cboType.GetCurSel();

}

void CEnterView::OnRadioType33() 
{
	// TODO: Add your control notification handler code here
	CEdit*  pGrid;
	int i;
	UpdateData();
	if(m_nScale==0) 
	{
		m_N=3;
		m_NUM=9;
	}
	else
	{
		m_N=4;
		m_NUM=16;
	}
	for(i=0;i<16;i++)
	{
		pGrid=(CEdit*)GetDlgItem(IDC_EDIT_START0+i);
		pGrid->ShowWindow(SW_HIDE);
		pGrid=(CEdit*)GetDlgItem(IDC_EDIT_END0+i);
		pGrid->ShowWindow(SW_HIDE);
	}
	for(i=0;i<9;i++)
	{
		pGrid=(CEdit*)GetDlgItem(IDC_EDIT_START_33_0+i);
		pGrid->ShowWindow(SW_SHOW);
		pGrid=(CEdit*)GetDlgItem(IDC_EDIT_END_33_0+i);
		pGrid->ShowWindow(SW_SHOW);
	}

}

void CEnterView::OnRadioType44() 
{
	CEdit*  pGrid;
	int i;
	UpdateData();
		if(m_nScale==0) 
	{
		m_N=3;
		m_NUM=9;
	}
	else
	{
		m_N=4;
		m_NUM=16;
	}
	for(i=0;i<16;i++)
	{
		pGrid=(CEdit*)GetDlgItem(IDC_EDIT_START0+i);
		pGrid->ShowWindow(SW_SHOW);
		pGrid=(CEdit*)GetDlgItem(IDC_EDIT_END0+i);
		pGrid->ShowWindow(SW_SHOW);
	}
	for(i=0;i<9;i++)
	{
		pGrid=(CEdit*)GetDlgItem(IDC_EDIT_START_33_0+i);
		pGrid->ShowWindow(SW_HIDE);
		pGrid=(CEdit*)GetDlgItem(IDC_EDIT_END_33_0+i);
		pGrid->ShowWindow(SW_HIDE);
	}
	
}

//DEL int CEnterView::Start2GoalL(unsigned char *start, unsigned char *goal)
//DEL {
//DEL 
//DEL }

void CEnterView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	// TODO: Add your specialized code here and/or call the base class
	//AfxMessageBox("OnUpdate");
	CChessDoc* pDoc=(CChessDoc*)  GetDocument();

	if(pDoc->m_bFileOpen )
	{	
	
		m_NUM=pDoc->m_NUM;
		m_N=pDoc->m_N;
		char buf[10];
		unsigned char * c=pDoc->m_strStart;
		if(m_N==3)
		{
			sprintf(buf,"%c",c[0]);
			m_strStart33_0=buf;
			sprintf(buf,"%c",c[1]);
			m_strStart33_1=buf;
			sprintf(buf,"%c",c[2]);
			m_strStart33_2=buf;
			sprintf(buf,"%c",c[3]);
			m_strStart33_3=buf;
			sprintf(buf,"%c",c[4]);
			m_strStart33_4=buf;
			sprintf(buf,"%c",c[5]);
			m_strStart33_5=buf;
			sprintf(buf,"%c",c[6]);
			m_strStart33_6=buf;
			sprintf(buf,"%c",c[7]);
			m_strStart33_7=buf;
			sprintf(buf,"%c",c[8]);
			m_strStart33_8=buf;

			c=pDoc->m_strEnd;
			sprintf(buf,"%c",c[0]);
			m_strEnd33_0=buf;
			sprintf(buf,"%c",c[1]);
			m_strEnd33_1=buf;
			sprintf(buf,"%c",c[2]);
			m_strEnd33_2=buf;
			sprintf(buf,"%c",c[3]);
			m_strEnd33_3=buf;
			sprintf(buf,"%c",c[4]);
			m_strEnd33_4=buf;
			sprintf(buf,"%c",c[5]);
			m_strEnd33_5=buf;
			sprintf(buf,"%c",c[6]);
			m_strEnd33_6=buf;
			sprintf(buf,"%c",c[7]);
			m_strEnd33_7=buf;
			sprintf(buf,"%c",c[8]);
			m_strEnd33_8=buf;
		}
		else if(m_N==4)
		{
			c=pDoc->m_strStart;
			sprintf(buf,"%c",c[0]);
			m_strStart44_0=buf;
			sprintf(buf,"%c",c[1]);
			m_strStart44_1=buf;
			sprintf(buf,"%c",c[2]);
			m_strStart44_2=buf;
			sprintf(buf,"%c",c[3]);
			m_strStart44_3=buf;
			sprintf(buf,"%c",c[4]);
			m_strStart44_4=buf;
			sprintf(buf,"%c",c[5]);
			m_strStart44_5=buf;
			sprintf(buf,"%c",c[6]);
			m_strStart44_6=buf;
			sprintf(buf,"%c",c[7]);
			m_strStart44_7=buf;
			sprintf(buf,"%c",c[8]);
			m_strStart44_8=buf;
			sprintf(buf,"%c",c[9]);
			m_strStart44_9=buf;
			sprintf(buf,"%c",c[10]);
			m_strStart44_A=buf;
			sprintf(buf,"%c",c[11]);
			m_strStart44_B=buf;
			sprintf(buf,"%c",c[12]);
			m_strStart44_C=buf;
			sprintf(buf,"%c",c[13]);
			m_strStart44_D=buf;
			sprintf(buf,"%c",c[14]);
			m_strStart44_E=buf;
			sprintf(buf,"%c",c[15]);
			m_strStart44_F=buf;
		
			c=pDoc->m_strEnd;
			sprintf(buf,"%c",c[0]);
			m_strEnd44_0=buf;
			sprintf(buf,"%c",c[1]);
			m_strEnd44_1=buf;
			sprintf(buf,"%c",c[2]);
			m_strEnd44_2=buf;
			sprintf(buf,"%c",c[3]);
			m_strEnd44_3=buf;
			sprintf(buf,"%c",c[4]);
			m_strEnd44_4=buf;
			sprintf(buf,"%c",c[5]);
			m_strEnd44_5=buf;
			sprintf(buf,"%c",c[6]);
			m_strEnd44_6=buf;
			sprintf(buf,"%c",c[7]);
			m_strEnd44_7=buf;
			sprintf(buf,"%c",c[8]);
			m_strEnd44_8=buf;
			sprintf(buf,"%c",c[9]);
			m_strEnd44_9=buf;
			sprintf(buf,"%c",c[10]);
			m_strEnd44_A=buf;
			sprintf(buf,"%c",c[11]);
			m_strEnd44_B=buf;
			sprintf(buf,"%c",c[12]);
			m_strEnd44_C=buf;
			sprintf(buf,"%c",c[13]);
			m_strEnd44_D=buf;
			sprintf(buf,"%c",c[14]);
			m_strEnd44_E=buf;
			sprintf(buf,"%c",c[15]);
			m_strEnd44_F=buf;


				
		}
	
		m_nScale=m_N-3;

		UpdateData(FALSE);
		if (m_nScale==0)
			OnRadioType33();
		else if(m_nScale==1)
			OnRadioType44();
	
	}
	else
	{
		m_nScale=0;
		OnRadioType33();
	}
	
}

void CEnterView::OnChangeEditDepth() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CFormView::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	
}

//DEL void CEnterView::OnDraw(CDC* pDC) 
//DEL {
//DEL 	// TODO: Add your specialized code here and/or call the base class
//DEL 	CChessDoc* pDoc=(CChessDoc*)  GetDocument();
//DEL 	CEdit *pEdit;
//DEL 	if(pDoc->m_bFileOpen )
//DEL 	{
//DEL 		m_NUM=pDoc->m_NUM;
//DEL 		m_N=pDoc->m_N;
//DEL 		char tempchar[10];
//DEL 		
//DEL 		for(BYTE i=0;i<m_NUM;i++)
//DEL 		{
//DEL 			sprintf(tempchar,"%c",pDoc->m_strStart[i]);
//DEL 
//DEL 			if(m_N==3)
//DEL 				pEdit=(CEdit*)GetDlgItem(IDC_EDIT_START_33_0+i);
//DEL 			else 
//DEL 				pEdit=(CEdit*)GetDlgItem(IDC_EDIT_START0+i);
//DEL 			
//DEL 			if (tempchar[0]=='0') tempchar[0]=NULL;
//DEL 			pEdit->SetWindowText(tempchar);
//DEL 		}
//DEL 		
//DEL 		for(i=0;i<m_NUM;i++)
//DEL 		{
//DEL 			sprintf(tempchar,"%c",pDoc->m_strEnd[i]);
//DEL 			if (m_N==3)
//DEL 				pEdit=(CEdit*)GetDlgItem(IDC_EDIT_END_33_0+i);
//DEL 			else
//DEL 				pEdit=(CEdit*)GetDlgItem(IDC_EDIT_END0+i);
//DEL 			if(tempchar[0]=='0') tempchar[0]=NULL;
//DEL 			pEdit->SetWindowText(tempchar);
//DEL 				
//DEL 		}
//DEL 	}
//DEL 	
//DEL }
